import _toConsumableArray from"@babel/runtime/helpers/toConsumableArray";import _classCallCheck from"@babel/runtime/helpers/classCallCheck";import _createClass from"@babel/runtime/helpers/createClass";import _possibleConstructorReturn from"@babel/runtime/helpers/possibleConstructorReturn";import _getPrototypeOf from"@babel/runtime/helpers/getPrototypeOf";import _inherits from"@babel/runtime/helpers/inherits";import _assertThisInitialized from"@babel/runtime/helpers/assertThisInitialized";import _defineProperty from"@babel/runtime/helpers/defineProperty";import"core-js/modules/es6.regexp.search";import"core-js/modules/es6.function.name";import _objectSpread from"@babel/runtime/helpers/objectSpread";var _dec,_dec2,_class,_class2,_temp;/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */import React,{Component}from"react";import withStyles from"@material-ui/core/styles/withStyles";import Button from"@material-ui/core/Button";import Input from"@material-ui/core/Input";import IconButton from"@material-ui/core/IconButton";import SearchIcon from"@material-ui/icons/Search";import SearchReset from"@material-ui/icons/Clear";import Typography from"@material-ui/core/Typography";import{types}from"mobx-state-tree";import PropTypes from"prop-types";import Highlight from"react-highlighter";import CircularProgress from"@material-ui/core/CircularProgress";import Link from"./Link";import{PropTypes as MobxPropTypes,inject,observer}from"mobx-react";import Image from"./Image";/**
 * A search popup with suggestions of search texts, categories, products.
 * can be used like composition
 * <SearchPopup>
 *   <SuggestedSearch />
 *   <CategorySearches />
 *   <ProductSuggestions />
 * </SearchPopup>
 */export var styles=function(a){return{searchPopup:{position:"fixed",top:0,bottom:0,left:0,right:0,backgroundColor:"rgba(255, 255, 255, .8)",zIndex:9999,padding:"20px"},closeButton:{backgroundColor:a.palette.white,border:"1px solid ".concat(a.palette.border),"& span":{textTransform:"uppercase",fontWeight:"bold"}},searchForm:{display:"flex",marginTop:"20px",position:"relative"},searchReset:{position:"absolute",top:0,right:"50px"},flexInput:{flexGrow:1,backgroundColor:a.palette.secondary.light,boxSizing:"border-box",height:48,padding:"8px 12px 8px 12px"},searchButton:{backgroundColor:a.palette.darkButton,borderRadius:0,"& svg":{fill:a.palette.white}},suggestionHeader:{textTransform:"uppercase",marginTop:"40px"},suggestionsList:{listStyle:"none",margin:0,padding:0,"& a strong":{fontWeight:"bold",color:a.palette.text.primary}},productImage:{height:"120px",width:"120px",display:"block",marginBottom:"15px"},productsSuggestions:{display:"flex",listStyle:"none",margin:0,padding:0,overflowX:"auto","& > li":{margin:"5px"}},searchResultsWrapper:{position:"absolute",top:"125px",bottom:0,overflowY:"auto",left:"20px",right:0},loading:{paddingTop:"20%",display:"flex",alignItems:"center",justifyContent:"center"}}};var SearchPopup=(_dec=withStyles(styles,{name:"RSFSearchPopup"}),_dec2=inject(function(a){var b=a.app,c=b.searchPopup,d=b.search,e=a.history;return{searchPopup:c,search:d,history:e}}),_dec(_class=_dec2(_class=observer(_class=(_temp=_class2=/*#__PURE__*/function(a){function b(){var a,c;_classCallCheck(this,b);for(var d=arguments.length,e=Array(d),f=0;f<d;f++)e[f]=arguments[f];return c=_possibleConstructorReturn(this,(a=_getPrototypeOf(b)).call.apply(a,[this].concat(e))),_defineProperty(_assertThisInitialized(_assertThisInitialized(c)),"state",{search:""}),_defineProperty(_assertThisInitialized(_assertThisInitialized(c)),"onChangeSearchText",function(a){var b=c.props.search;c.setState({search:a}),b.setLoading(!!a),b.run(a)}),_defineProperty(_assertThisInitialized(_assertThisInitialized(c)),"hidePopup",function(){var a=c.props.searchPopup;a.setIsPopupOpened(!1),c.onChangeSearchText("")}),_defineProperty(_assertThisInitialized(_assertThisInitialized(c)),"onSearchSubmit",function(a){var b=c.props.history;a.preventDefault(),b.push("/search?text=".concat(c.state.search)),c.hidePopup()}),c}return _inherits(b,a),_createClass(b,[{key:"render",value:function m(){var a=this,b=this.props,c=b.searchPopup,d=b.classes,e=b.search,f=b.children,g=b.suggestionResultsLimit,h=_toConsumableArray(e.searches).splice(0,g),i=_toConsumableArray(e.categories).splice(0,g),j=React.Children.map(f,function(b){return React.cloneElement(b,{searches:h,classes:d,categories:i,products:e.products,searchText:a.state.search,hidePopup:a.hidePopup})}),k=e.loading,l=this.state.search&&!k;return React.createElement("form",{onSubmit:this.onSearchSubmit,onReset:function b(){a.onChangeSearchText("")}},c.opened&&React.createElement("div",{className:d.searchPopup},React.createElement(Button,{className:d.closeButton,variant:"contained",onClick:this.hidePopup},"Cancel"),React.createElement("div",{className:d.searchForm},React.createElement(Input,{type:"text",className:d.flexInput,value:this.state.search,onChange:function c(b){a.onChangeSearchText(b.target.value)}}),React.createElement(IconButton,{variant:"contained",type:"submit",className:d.searchButton},React.createElement(SearchIcon,null)),this.state.search&&React.createElement(IconButton,{type:"reset",className:d.searchReset},React.createElement(SearchReset,null))),k&&React.createElement("div",{className:d.loading},React.createElement(CircularProgress,null)),l&&React.createElement("div",{className:d.searchResultsWrapper},j)))}}]),b}(Component),_defineProperty(_class2,"defaultProps",{suggestionResultsLimit:3}),_defineProperty(_class2,"propTypes",{/**
     * searchPopup holds state of popup
     */searchPopup:PropTypes.shape({opened:PropTypes.bool.isRequired}),/**
     * search contains lists of suggestions
     */search:PropTypes.shape({searches:MobxPropTypes.arrayOrObservableArrayOf(PropTypes.shape({text:PropTypes.string})),categories:MobxPropTypes.arrayOrObservableArrayOf(PropTypes.shape({id:PropTypes.string,url:PropTypes.string,name:PropTypes.string})),products:MobxPropTypes.arrayOrObservableArrayOf(PropTypes.shape({id:PropTypes.string,url:PropTypes.string,name:PropTypes.string,image:PropTypes.string}))}),/**
     * limit for suggestion results list
     */suggestionResultsLimit:PropTypes.number,/**
     * Suggestion results components
     */children:PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node),PropTypes.node]).isRequired,history:PropTypes.shape({push:PropTypes.func.isRequired})}),_temp))||_class)||_class)||_class);export{SearchPopup as default};var commonPropTypes={hidePopup:PropTypes.func,classes:PropTypes.shape({suggestionHeader:PropTypes.string,suggestionsList:PropTypes.string})/**
 * Search text suggestions
 * @param props
 * @constructor
 */};export var SuggestedSearch=function(a){return React.createElement(React.Fragment,null,React.createElement(Typography,{component:"h2",className:a.classes.suggestionHeader},"Suggested search"),React.createElement("ul",{className:a.classes.suggestionsList},a.searches.map(function(b,c){return React.createElement("li",{key:c},React.createElement(Link,{to:"/search?text=".concat(b.text),onClick:a.hidePopup},React.createElement(Highlight,{search:a.searchText},b.text)))})))};SuggestedSearch.propTypes=_objectSpread({},commonPropTypes,{searches:MobxPropTypes.arrayOrObservableArrayOf(PropTypes.shape({text:PropTypes.string})),searchText:PropTypes.string/**
 * Search categories suggestions
 * @param props
 * @constructor
 */});export var CategorySearches=function(a){return React.createElement(React.Fragment,null,React.createElement(Typography,{component:"h2",className:a.classes.suggestionHeader},"Category searches"),React.createElement("ul",{className:a.classes.suggestionsList},a.categories.map(function(b){return React.createElement("li",{key:b.id},React.createElement(Link,{to:b.url,onClick:a.hidePopup},b.name))})))};CategorySearches.propTypes=_objectSpread({},commonPropTypes,{categories:MobxPropTypes.arrayOrObservableArrayOf(PropTypes.shape({id:PropTypes.string,url:PropTypes.string,name:PropTypes.string}))/**
 * Search products suggestions
 * @param props
 * @constructor
 */});export var ProductSuggestions=function(a){return React.createElement(React.Fragment,null,React.createElement(Typography,{component:"h2",className:a.classes.suggestionHeader},"Product suggestions"),React.createElement("ul",{className:a.classes.productsSuggestions},a.products.map(function(b){return React.createElement("li",{key:b.id},React.createElement(Link,{to:b.url,onClick:a.hidePopup,className:a.classes.productImage},React.createElement(Image,{fill:!0,src:b.thumbnail,alt:b.name})),React.createElement(Link,{to:b.url,onClick:a.hidePopup},b.name))})))};ProductSuggestions.propTypes=_objectSpread({},commonPropTypes,{products:MobxPropTypes.arrayOrObservableArrayOf(PropTypes.shape({id:PropTypes.string,url:PropTypes.string,name:PropTypes.string,thumbnail:PropTypes.string}))/**
 * Search popup model
 */});export var SearchPopupModel=types.model("SearchPopupModel",{opened:types.boolean}).actions(function(a){return{setIsPopupOpened:function c(b){return a.opened=b,a}}});
//# sourceMappingURL=SearchPopup.js.map