import"core-js/modules/es6.function.name";import"core-js/modules/es7.symbol.async-iterator";import"core-js/modules/es6.symbol";import"core-js/modules/web.dom.iterable";import _objectSpread from"@babel/runtime/helpers/objectSpread";import _regeneratorRuntime from"@babel/runtime/regenerator";import"regenerator-runtime/runtime";import _asyncToGenerator from"@babel/runtime/helpers/asyncToGenerator";import _objectWithoutProperties from"@babel/runtime/helpers/objectWithoutProperties";import"core-js/modules/es6.regexp.to-string";import _classCallCheck from"@babel/runtime/helpers/classCallCheck";import _createClass from"@babel/runtime/helpers/createClass";import _possibleConstructorReturn from"@babel/runtime/helpers/possibleConstructorReturn";import _getPrototypeOf from"@babel/runtime/helpers/getPrototypeOf";import _inherits from"@babel/runtime/helpers/inherits";import _defineProperty from"@babel/runtime/helpers/defineProperty";var _dec,_class,_class2,_temp;/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */import React,{Component}from"react";import{inject}from"mobx-react";import PropTypes from"prop-types";import analytics,{getTargets}from"./analytics";var nextId=0,ampAnalyticsTypes={};/**
 * @private
 * Used to reset the id for repeatable test results.
 */export function resetId(){nextId=0}/**
 * Fires an analytics event when the user interacts with the child component.  By default this fires when the user
 * clicks on the child component, but this can be overriden using the `trigger` prop.  The value of trigger should
 * be the name of the event prop to bind to. All additional props will be passed as options along with the event.
 * 
 * Example:
 * 
 * <Track event="addedToCart" product={this.props.product}>
 *  <Button>Add to Cart</Button>
 * </Track>
 */var Track=(_dec=inject("app"),_dec(_class=(_temp=_class2=/*#__PURE__*/function(a){function b(){var a;return _classCallCheck(this,b),a=_possibleConstructorReturn(this,_getPrototypeOf(b).call(this)),a.id=(nextId++).toString(),a}return _inherits(b,a),_createClass(b,[{key:"componentWillMount",value:function h(){if(this.props.app.amp){var a=this.props,b=a.event,c=a.trigger,d=a.app,e=a.children,f=a.onSuccess,g=_objectWithoutProperties(a,["event","trigger","app","children","onSuccess"]);this.createAmpTriggers(g)}}},{key:"render",value:function a(){return this.attachEvent()}/**
   * Fires the analytics event asynchronously using setImmediate so as not to 
   * block the render loop.
   */},{key:"fireEvent",value:function i(){var a=this.props,b=a.event,c=a.trigger,d=a.app,e=a.children,f=a.onSuccess,g=a.ampData,h=_objectWithoutProperties(a,["event","trigger","app","children","onSuccess","ampData"]);setImmediate(/*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(){return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:return a.next=2,analytics.fire(b,h);case 2:f();case 3:case"end":return a.stop();}},a,this)})))}/**
   * Intecepts the child's event handler prop corresponding to this.props.trigger
   * and returns the cloned child.
   * @return {React.Element}
   */},{key:"attachEvent",value:function h(){var a=this,b=this.props,c=b.app.amp,d=b.trigger,e=b.children;if(e){var f=e.props[d],g=_objectSpread({},e.props,_defineProperty({},d,function(){f&&f.apply(void 0,arguments),a.fireEvent()}));return c&&(g["data-amp-id"]=this.id,g["data-vars-moov-test"]="foo"),React.cloneElement(e,g)}return null}/**
   * Creates AMP event trigger objects based on this.props.event
   */},{key:"createAmpTriggers",value:function n(a){var b=this.props,c=b.event,d=b.children,e=b.ampData,f=!0,g=!1,h=void 0;try{for(var i,j=getTargets()[Symbol.iterator]();!(f=(i=j.next()).done);f=!0){var k=i.value,l=k[c],m=k.getAmpAnalyticsType();if(l&&m){var o=void 0;// Override send to capture the data that would be send instead of trying to send it
k.send=function(a){return o=a},l.call(k,a),o?(!o.trigger&&d&&(o.selector="[data-amp-id=\"".concat(this.id,"\"]")),this.configureAmpEvent(m,_objectSpread({on:o.selector?"click":"visible"},o,{request:"event"},e))):console.log("WARNING: No data will be sent for the ".concat(c," event when running in AMP because ").concat(k.constructor.name," didn't return any data for this event."))}}}catch(a){g=!0,h=a}finally{try{f||null==j.return||j.return()}finally{if(g)throw h}}}/**
   * Adds an AMP analytics event trigger
   * @param {String} type An AMP analytics event type, e.g. googleanalytics
   * @param {Object} trigger The trigger descriptor object
   */},{key:"configureAmpEvent",value:function d(a,b){var c=ampAnalyticsTypes[a];c||(c=ampAnalyticsTypes[a]={triggers:[]}),c.triggers.push(b)}}]),b}(Component),_defineProperty(_class2,"propTypes",{/**
     * The name of the method to call on all configured analytics targets.
     * For example, "addedToCart".
     */event:PropTypes.string.isRequired,/**
     * The name of the handler prop on child component to intercept.  Defaults to "onClick"
     */trigger:PropTypes.string,/**
     * A function to call once the event has been successfully sent by all analytics targets.
     */onSuccess:PropTypes.func,/**
     * Additional data to send when tracking events in AMP.
     */ampData:PropTypes.object}),_defineProperty(_class2,"defaultProps",{trigger:"onClick",onSuccess:Function.prototype,ampData:{}}),_temp))||_class);export{Track as default};export function renderAmpAnalyticsTags(){var a=[];for(var b in ampAnalyticsTypes)a.push("<amp-analytics".concat("gtm"==b?"":" type=\"".concat(b,"\""),">")+"<script type=\"application/json\">".concat(JSON.stringify(ampAnalyticsTypes[b]),"</script>")+"</amp-analytics>");return ampAnalyticsTypes={},a.join("\n")}
//# sourceMappingURL=Track.js.map