import _classCallCheck from"@babel/runtime/helpers/classCallCheck";import _possibleConstructorReturn from"@babel/runtime/helpers/possibleConstructorReturn";import _getPrototypeOf from"@babel/runtime/helpers/getPrototypeOf";import _inherits from"@babel/runtime/helpers/inherits";import _assertThisInitialized from"@babel/runtime/helpers/assertThisInitialized";import _wrapNativeSuper from"@babel/runtime/helpers/wrapNativeSuper";import _defineProperty from"@babel/runtime/helpers/defineProperty";import"core-js/modules/es6.function.name";import _objectSpread from"@babel/runtime/helpers/objectSpread";/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */ /**
 * Creates a fetch function with an internal incrementing request counter that ensures that out of order
 * responses result in a StaleResponseError.
 * 
 * Example usage:
 *  
 *  import { fetchLatest, StaleResponseError } from 'react-storefront/fetch'
 * 
 *  const fetch = fetchLatest()
 * 
 *  try {
 *    const response = await fetch('/some/url')
 *  } catch (e) {
 *    if (!StaleResponseError.is(e)) { 
 *      throw e // just ignore stale responses, rethrow all other errors
 *    }
 *  }
 * 
 * @return {Function}
 */export function fetchLatest(a){var b,c=0,d=function(){return b&&b.abort(),"undefined"==typeof AbortController?{signal:null}:b=new AbortController};return function(b,e){var f=++c,g=d().signal;return a(b,_objectSpread({},e,{signal:g})).then(function(a){if(f!=c)throw new StaleResponseError;return a}).catch(function(a){// For browsers that support AbortController, ensure that the behavior is the same as browsers that don't - 
// StaleResponseError should be thrown in either case
if("AbortError"===a.name)throw new StaleResponseError;else throw a})}}/**
 * Thrown when an out of order response is received
 */export var StaleResponseError=/*#__PURE__*/function(a){function b(){var a,c;_classCallCheck(this,b);for(var d=arguments.length,e=Array(d),f=0;f<d;f++)e[f]=arguments[f];return c=_possibleConstructorReturn(this,(a=_getPrototypeOf(b)).call.apply(a,[this].concat(e))),_defineProperty(_assertThisInitialized(_assertThisInitialized(c)),"name","StaleResponseError"),c}return _inherits(b,a),b}(_wrapNativeSuper(Error));_defineProperty(StaleResponseError,"is",function(a){return"StaleResponseError"===a.name});
//# sourceMappingURL=fetchLatest.js.map