import"core-js/modules/es6.regexp.replace";import"core-js/modules/es6.regexp.search";/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */import{types}from"mobx-state-tree";import{MenuModel}from"../Menu";import{TabsModel}from"../NavTabs";import CategoryModelBase from"./CategoryModelBase";import SubcategoryModelBase from"./SubcategoryModelBase";import ProductModelBase from"./ProductModelBase";import UserModelBase from"./UserModelBase";import CartModelBase from"./CartModelBase";import SearchModelBase from"./SearchModelBase";import isEqual from"lodash/isEqual";/**
 * Represents a single breadcrumb
 */export var BreadcrumbModel=types.model("BreadcrumbModel",{/**
     * The URL to link to
     */url:types.maybeNull(types.string),/**
     * The text for the link
     */text:types.string,/**
     * An object to be applied to the state tree when the breadcrumb is clicked.  The shape should match your AppModel class.
     */state:types.frozen()});export var LocationModel=types.model({protocol:"https",hostname:types.maybeNull(types.string),pathname:types.string,search:types.string,port:"443"});var AppModelBase=types.model("AppModelBase",{amp:!1,initialWidth:"xs",page:types.maybeNull(types.string),title:types.maybeNull(types.string),description:types.maybeNull(types.string),loading:!1,error:types.maybeNull(types.string),stack:types.maybeNull(types.string),menu:types.optional(MenuModel,{}),tabs:types.maybeNull(TabsModel),category:types.maybeNull(CategoryModelBase),subcategory:types.maybeNull(SubcategoryModelBase),product:types.maybeNull(ProductModelBase),loadingProduct:types.maybeNull(ProductModelBase),loadingSubcategory:types.maybeNull(SubcategoryModelBase),loadingCategory:types.maybeNull(CategoryModelBase),user:types.maybeNull(UserModelBase),location:types.maybeNull(LocationModel),search:types.optional(SearchModelBase,{}),breadcrumbs:types.optional(types.array(BreadcrumbModel),[]),cart:types.optional(CartModelBase,{})}).views(function(a){return{get canonicalURL(){var b=a.location,c=b.protocol,d=b.hostname,e=b.pathname,f=b.search;return c+"//"+d+e.replace(/\.amp$/,"")+f},get uri(){return a.location.pathname+a.location.search}}}).actions(function(a){return{/**
     * Clears the thumbnail being injected into the product skeleton
     */clearProductThumbnail:function b(){a.productThumbnail=null},/**
     * Applies a patch to the state tree
     * @param {Object} patch The patch to apply
     * @param {String} action "PUSH", "POP", or "REPLACE"
     */applyState:function d(b,c){if("POP"===c)// the user clicked the browser's back button
// ensure that state not corresponding to the URL is retained, for example the user and cart
// ensure that data for other pages is not changed.  This minimizes component reconciliation to boost performance
// apply the page change first so the UI swaps to the previous page immediately
// if we're still loading the current page, we can hide the load mask immediately because we're going back to the previous page
b=a.retainStateOnHistoryPop(b),auditPatchOnPop(a,b),a.page=b.page,a.loading=!1,setImmediate(function(){return a.applyState(b)});else{// all other navigation
var e=a.toJSON();for(var f in b){var g=b[f];isEqual(g,e[f])||(a[f]=g)}}},/**
     * Returns the part of the state tree which should not be overwritten
     * when the user goes forward or back.  You can override this action
     * to retain additional branches of the tree.
     */retainStateOnHistoryPop:function b(a){return delete a.cart,delete a.user,delete a.menu,delete a.tabs,a},/**
     * Sets the user model
     * @param {UserModelBase} user 
     */signIn:function c(b){a.user=b},/**
     * Cleares the user model
     */signOut:function b(){a.user=null},/**
     * Restores the user identity
     * @param {UserModelBase} user 
     */setUser:function c(b){a.user=b},/**
     * Displays an error state
     * @param {Error} e 
     */onError:function c(b){a.page="Error",a.error=b.message,a.stack=b.stack}}});/**
 * Removes values from the patch corresponding to existing values in the model that
 * implement forPage and for which forPage does not match the page being set in the patch.
 * 
 * This helps minimize react component reconciliation by ensuring that values corresponding to
 * hidden pages are not changed when navigating back.
 * 
 * @param {AppModelBase} model The app model instance
 * @param {Object} patch The patch to be applied
 */function auditPatchOnPop(a,b){if(b.page)for(var c in b){var d=a[c];d&&d.shouldApplyPatchOnPop&&!d.shouldApplyPatchOnPop(b)&&delete b[c]}}export default AppModelBase;
//# sourceMappingURL=AppModelBase.js.map