import _regeneratorRuntime from"@babel/runtime/regenerator";import"core-js/modules/es6.regexp.search";import"regenerator-runtime/runtime";import _asyncToGenerator from"@babel/runtime/helpers/asyncToGenerator";/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */import fetch from"fetch";import debounce from"lodash/debounce";import{types}from"mobx-state-tree";import{fetchLatest,StaleResponseError}from"../fetchLatest";// Ensures that responses are returned in order and that the previous request is canceled when a new request is sent.
var fetchSearchResults=fetchLatest(fetch);/**
 * Represents an individual link within a group
 */export var ResultsModel=types.model("ResultsModel",{/**
     * The link text
     */text:types.string,/**
     * The link's target url
     */url:types.string,/**
     * A url for a thumbnail image
     */thumbnail:types.maybeNull(types.string),/**
     * The thumbnail height
     */thumbnailHeight:120,/**
     * The thumbnail width
     */thumbnailWidth:120});/**
 * Represents a group of links withing the search results
 */export var ResultsGroupModel=types.model("ResultsGroupModel",{/**
     * The caption to display at the top of the group
     */caption:types.string,/**
     * The list of links to display
     */results:types.optional(types.array(ResultsModel),[])}).views(function(a){return{get thumbnails(){return a.results.some(function(a){return null!=a.thumbnail})}}});/**
 * The base model for site-wide searches.
 */var SearchModelBase=types.model("SearchModelBase",{/**
     * The search phrase entered by the user
     */text:"",/**
     * The resulting groups
     */groups:types.optional(types.array(ResultsGroupModel),[]),/**
     * True to show the loading sprinner
     */loading:!1,/**
     * True to show the search popup
     */show:!1}).actions(function(a){return{/**
     * Set `true` to show the search popup, `false` to hide.
     * @param {Boolean} show 
     */toggle:function c(b){a.show=b},/**
     * Update the search text
     * @param {String} text 
     */setText:function c(b){a.text=b,a.loading=0<a.text.trim().length,a.submit(b)},/**
     * Set `true` to show the loading spinner, `false` to hide.
     * @param {Boolean} state 
     */setLoading:function c(b){a.loading=b},/**
     * Submit the search for the given keyword.  Fetched calls are automatically debounced and serialized so that
     * results are received in order.
     * @param {String} keyword
     */submit:debounce(/*#__PURE__*/function(){var b=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function b(c){var d;return _regeneratorRuntime.wrap(function(b){for(;;)switch(b.prev=b.next){case 0:if(c){b.next=2;break}return b.abrupt("return");case 2:return b.prev=2,b.next=5,fetchSearchResults("/search/suggest.json?q=".concat(encodeURIComponent(c))).then(function(a){return a.json()});case 5:d=b.sent,a.setGroups(d.search.groups),a.setLoading(!1),b.next=15;break;case 10:if(b.prev=10,b.t0=b["catch"](2),StaleResponseError.is(b.t0)){b.next=15;break}throw a.setLoading(!1),b.t0;case 15:case"end":return b.stop();}},b,this,[[2,10]])}));return function(){return b.apply(this,arguments)}}(),500),/**
     * Set the groups to be displayed
     * @param {ResultsGroupModel[]} groups 
     */setGroups:function c(b){a.groups=b}}});export default SearchModelBase;
//# sourceMappingURL=SearchModelBase.js.map