import _toConsumableArray from"@babel/runtime/helpers/toConsumableArray";import"core-js/modules/es6.regexp.search";import _asyncToGenerator from"@babel/runtime/helpers/asyncToGenerator";import _regeneratorRuntime from"@babel/runtime/regenerator";import"regenerator-runtime/runtime";/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */import{types,isAlive,flow}from"mobx-state-tree";import fetch from"fetch";import ProductModelBase from"./ProductModelBase";export var LAYOUT_LIST="LAYOUT_LIST";export var LAYOUT_GRID="LAYOUT_GRID";/**
 * A search facet that can be applied as a filter
 */export var FacetModelBase=types.model("FacetModelBase",{/**
   * The value sent to the API when filtering
   */code:types.maybeNull(types.string),/**
   * The text displayed in the UI
   */name:types.identifier,/**
   * The number of items having the value
   */matches:types.maybeNull(types.number)});/**
 * A grouping of facets
 */export var FacetGroupModelBase=types.model("FacetGroupModelBase",{/**
   * The text displayed in the UI
   */name:types.identifier,/**
   * The facets in the group
   */facets:types.optional(types.array(FacetModelBase),[])});/**
 * A value by which results can be sorted
 */export var SortBase=types.model("SortBase",{/**
   * The code sent to the API when sorting
   */code:types.identifier,/**
   * The text displayed in the UI
   */name:types.maybeNull(types.string)});/**
 * A base class for search results and subcategories that supports filtering and sorting
 */export default types.model("SearchResultsModelBase",{/**
     * The codes of the currently applied filters
     */filters:types.optional(types.array(types.string),[]),/**
     * Automatically set to true when the user has changed a filter.  This causes
     * the filter dialog footer to be displayed.
     */filtersChanged:!1,/**
     * Filters that can be selected
     */facetGroups:types.optional(types.array(FacetGroupModelBase),[]),/**
     * The code for the currently selected sort option
     */sort:types.maybeNull(types.string),/**
     * Sort options that can be selected
     */sortOptions:types.optional(types.array(SortBase),[]),/**
     * The total number of matching items. You can either specify numberOfPages or total to determine
     * when to display the Show More Button.  Only one is required.
     */total:types.maybeNull(types.number),/**
     * The total number of pages.  You can either specify numberOfPages or total to determine
     * when to display the Show More Button.  Only one is required.
     */numberOfPages:types.maybeNull(types.number),/**
     * The matching items
     */items:types.optional(types.array(ProductModelBase),[]),/**
     * Set to true when fetching data from the server in response to a filter or sort change.
     */loading:!1,/**
     * Set to true when loading more items from the server is in progress.
     */loadingMore:!1,/**
     * The current page being displayed
     */page:0,/**
     * The maximum number of records per page
     */pageSize:10,/**
     * Sets the layout style on the view.  Can be LAYOUT_LIST or LAYOUT_GRID.  Defaults to LAYOUT_GRID.
     */layout:types.optional(types.enumeration("Layout",["LAYOUT_LIST","LAYOUT_GRID"]),"LAYOUT_GRID")}).views(function(a){return{get hasMoreItems(){return null==a.numberOfPages?null!=a.total&&a.total>a.items.length:a.numberOfPages-1>a.page}}}).actions(function(a){return{/**
     * Removes all filters.
     */clearAllFilters:function b(){a.filters.clear(),a.filtersChanged=!0},/**
     * Sets the filtersChanged field
     * @param {Boolean} changed
     */setFiltersChanged:function c(b){a.filtersChanged=b},/**
     * Refreshes the search based on the current filters and sort and resets the page to 0.
     */refresh:flow(/*#__PURE__*/_regeneratorRuntime.mark(function b(){return _regeneratorRuntime.wrap(function(b){for(;;)switch(b.prev=b.next){case 0:return a.filtersChanged=!1,a.loading=!0,b.next=4,a.showPage(0);case 4:a.loading=!1;case 5:case"end":return b.stop();}},b,this)})),/**
     * Toggles a facet on or off.
     * @param {FacetModelBase} facet
     */toggleFilter:function e(b){var c=b.code,d=a.filters.indexOf(c);-1===d?a.filters.push(c):a.filters.splice(d,1),a.filtersChanged=!0},showPage:function(){var b=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function b(c){var d,e,f,g;return _regeneratorRuntime.wrap(function(b){for(;;)switch(b.prev=b.next){case 0:return a.page=c,d=window.location,e=d.pathname,f=d.search,f+="".concat(f.length?"&":"?","page=").concat(a.page),b.prev=3,a.loadingMore=0<c,b.next=7,fetch(a.getShowMoreURL("".concat(e,".json").concat(f))).then(function(a){return a.json()});case 7:g=b.sent,isAlive(a)&&(a.addItems(g.items),a.setTotal(g.total));case 9:return b.prev=9,isAlive(a)&&a.endLoadingMore(),b.finish(9);case 12:case"end":return b.stop();}},b,this,[[3,,9,12]])}));return function a(){return b.apply(this,arguments)}}(),/**
     * Fetches the next page from the server.
     */showMore:function(){var b=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function b(){return _regeneratorRuntime.wrap(function(b){for(;;)switch(b.prev=b.next){case 0:if(a.loading){b.next=3;break}return b.next=3,a.showPage(a.page+1);case 3:case"end":return b.stop();}},b,this)}));return function a(){return b.apply(this,arguments)}}(),getShowMoreURL:function b(a){return a},/**
     * Hides the loading more spinner.
     */endLoadingMore:function b(){a.loadingMore=!1},/**
     * Adds more items to the results
     * @param {Array} items
     */addItems:function c(b){0===a.page&&(a.items=[]),Array.isArray(b)&&(a.items=[].concat(_toConsumableArray(a.items),_toConsumableArray(b))),a.endLoadingMore()},/**
     * Sets the total number of matching records
     * @param {Integer} total 
     */setTotal:function c(b){a.total=b},/**
     * Toggles the layout
     * @param {String} layout LAYOUT_LIST or LAYOUT_GRID
     */switchLayout:function c(b){a.layout=b},/**
     * Sets the selected sort option
     */setSort:function c(b){a.sort=b.code}}});
//# sourceMappingURL=SearchResultsModelBase.js.map