import _extends from"@babel/runtime/helpers/extends";import"core-js/modules/es6.object.assign";import"core-js/modules/es6.regexp.split";import _slicedToArray from"@babel/runtime/helpers/slicedToArray";import"core-js/modules/es6.regexp.to-string";import"core-js/modules/web.dom.iterable";import"core-js/modules/es6.array.iterator";import"core-js/modules/es6.string.iterator";import"core-js/modules/es6.map";import"core-js/modules/es6.string.ends-with";import"core-js/modules/es6.array.find";import"core-js/modules/es6.regexp.replace";/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */import React from"react";import ReactDOM from"react-dom";import{renderToString}from"react-dom/server";import{Provider}from"mobx-react";import{SheetsRegistry}from"react-jss/lib/jss";import JssProvider from"react-jss/lib/JssProvider";import{create}from"jss";import{jssPreset}from"@material-ui/core/styles";import jssNested from"jss-nested";import{MuiThemeProvider}from"@material-ui/core/styles";import createGenerateClassName from"./utils/createGenerateClassName";// Escape <\ in a closing script tag to avoid untimely script closing
var getSanitizedModelJson=function(a){return JSON.stringify(a.toJSON()).replace(/<\/script/gi,"<\\/script")};/**
 * Get javascript asset filename by chunk name 
 * @param  {Object} stats Webpack generated stats
 * @param  {String} chunk Chunk name
 * @return {String}       Asset filename
 */export function getJS(a,b){var c=a.assetsByChunkName[b];return c?Array.isArray(c)?c.find(function(a){return a.endsWith(".js")}):c:null}/**
 * Gets all source paths for the given chunk
 * @param  {Object} stats Webpack generated stats
 * @param  {String} chunk Chunk name
 * @return {String[]}
 */function getSources(a,b){var c=[],d=getJS(a,b),e=getJS(a,"vendors~".concat(b));return d&&c.push(d),e&&c.push(e),c}/**
 * Render HTML of given component
 * @param  {React.Component} options.component Component to be rendered
 * @param  {Object} options.providers          Data providers
 * @param  {Object} options.registry           JSS Sheets Registry
 * @param  {Object} options.theme              MUI Theme
 * @param  {Object} options.cssPrefix          A prefix to apply to css classes
 * @return {String}                            HTML
 */export function renderHtml(a){var b=a.component,c=a.providers,d=a.registry,e=a.theme,f=a.cssPrefix,g=void 0===f?"jss":f;return renderToString(React.createElement(Provider,c,React.createElement(JssProvider,{classNamePrefix:g,registry:d,generateClassName:createGenerateClassName()},React.createElement(MuiThemeProvider,{theme:e,sheetsManager:new Map},b))))}/**
 * Renders initial state for client side hydration
 * @param  {Object} options.state                 Model instance
 * @param  {Boolean} options.defer                Should defer execution
 * @param  {String} options.initialStateProperty  Property name on window object
 * @return {String}                               Script HTML
 */export function renderInitialStateScript(a){var b=a.state,c=a.defer,d=a.initialStateProperty,e=void 0===d?"initialState":d;return"<script type=\"text/javascript\" ".concat(c?"defer":"",">\n\t\twindow.moov = { apiVersion: ").concat(JSON.stringify(__webpack_hash__)," }\n\t\twindow.").concat(e,"=Object.freeze(").concat(getSanitizedModelJson(b),")\n\t</script>")}/**
 * Renders script for a specified chunk
 * @param  {Object} options.stats   Webpack generated stats
 * @param  {String} options.chunk   Chunk name
 * @param  {Boolean} options.defer  Should defer execution
 * @return {String}                 Script HTML
 */export function renderScript(a){var b=a.stats,c=a.chunk,d=a.defer,e=process.env.ASSET_PATH_BASE||"";return getSources(b,c).map(function(a){return"<script type=\"text/javascript\" ".concat(d?"defer":""," src=\"").concat(e,"/pwa/").concat(a,"\"></script>")}).join("")}/**
 * Renders extracted CSS from Sheets Registry
 * @param  {Object} options.registry  JSS Sheets Registry
 * @param  {String} options.id        ID for style tag
 * @return {String}                   Style HTML
 */export function renderStyle(a){var b=a.registry,c=a.id,d=void 0===c?"ssr-css":c;return"<style id=\"".concat(d,"\">").concat(b.toString(),"</style>")}/**
 * Helper for extracting location object from Adapt environment
 * @param  {Object} env Adapt Environment
 * @return {Object}     Location Object
 */function getLocation(a){var b=a.path.split("?"),c=_slicedToArray(b,2),d=c[0],e=c[1];return{protocol:a.secure?"https":"http",hostname:a.host,pathname:d,search:e||""}}/**
 * Renders a component on the server.
 * @param  {React.Component} options.component    Component to be rendered
 * @param  {Object} options.state                 Model instance
 * @param  {Object} options.theme                 MUI Theme
 * @param  {Object} options.stats                 Webpack generated stats
 * @param  {String} options.clientChunk           Chunk name for hydration script
 * @param  {String} options.initialStateProperty  Optional window property name for initial state
 * @param  {Boolean} options.injectAssets					Defaults to true.  Set this to false to prevent scripts and css from automatically being injected into the document.
 * @param  {String} options.cssPrefix 						A prefix to apply to css class names
 * @return {Object}                               Components for SSR
 */export function render(a){var b=a.component,c=a.state,d=a.theme,e=a.stats,f=a.clientChunk,g=a.initialStateProperty,h=a.injectAssets,i=a.cssPrefix,j=new SheetsRegistry;c.applyState({location:getLocation(env)},"REPLACE");var k=renderHtml({component:b,providers:{app:c},registry:j,theme:d,cssPrefix:i}),l={html:k,style:renderStyle({registry:j}),initialStateScript:renderInitialStateScript({state:c,defer:!1,initialStateProperty:g}),bootstrapScript:renderScript({stats:e,chunk:"bootstrap"}),componentScript:renderScript({stats:e,chunk:f})};return(void 0===h||h)&&($head.append(l.style),$body.append(l.initialStateScript),$body.append(l.bootstrapScript),$body.append(l.componentScript)),l}/**
 * Hydrates React component
 * @param  {React.Component} options.component    Component to be rendered
 * @param  {Model} options.model                  MobX Model
 * @param  {Object} options.theme                 MUI Theme
 * @param  {String} options.target                Selector for rendering target 
 * @param  {String} options.providerProps         Props to add the to <Provider/> element
 * @param  {String} options.initialStateProperty  Optional window property name for initial state
 * @return {Object} The app state
 */export function hydrate(a){var b=a.component,c=a.model,d=a.theme,e=a.target,f=a.providerProps,g=void 0===f?{}:f,h=a.initialStateProperty,i=void 0===h?"initialState":h,j=a.cssPrefix,k=void 0===j?"jss":j,l=createGenerateClassName(),m=c.create(window[i]||{}),n=create(jssPreset(),jssNested());// skip jss insertion if we are hydrating SSR cached by the service worker because it has already been mounted
if(Object.assign(window.moov,{state:m,timing:{}},g),!document.body.hasAttribute("data-jss-inserted")){var o=document.createComment("jss-insertion-point");document.head.insertBefore(o,document.head.firstChild),n.options.insertionPoint="jss-insertion-point",document.body.setAttribute("data-jss-inserted","on")}return ReactDOM.hydrate(React.createElement(Provider,_extends({app:m},g),React.createElement(JssProvider,{classNamePrefix:k,jss:n,generateClassName:l},React.createElement(MuiThemeProvider,{theme:d},b))),e,removeSSRStyles),m}/**
 * Removes the style tag rendered on the server so that components are styled correctly 
 * after hydration.
 */function removeSSRStyles(){var a=document.getElementById("ssr-css");a&&a.parentNode&&a.parentNode.removeChild(a)}
//# sourceMappingURL=renderers.js.map