import"core-js/modules/es6.promise";import"core-js/modules/es6.string.ends-with";import"core-js/modules/es6.regexp.replace";import"core-js/modules/es6.array.find";import"core-js/modules/es6.regexp.match";import _objectSpread from"@babel/runtime/helpers/objectSpread";import _objectWithoutProperties from"@babel/runtime/helpers/objectWithoutProperties";import"core-js/modules/es7.symbol.async-iterator";import"core-js/modules/es6.symbol";import"core-js/modules/web.dom.iterable";import _regeneratorRuntime from"@babel/runtime/regenerator";import"core-js/modules/es6.regexp.search";import"regenerator-runtime/runtime";import _asyncToGenerator from"@babel/runtime/helpers/asyncToGenerator";import _classCallCheck from"@babel/runtime/helpers/classCallCheck";import _createClass from"@babel/runtime/helpers/createClass";import _possibleConstructorReturn from"@babel/runtime/helpers/possibleConstructorReturn";import _getPrototypeOf from"@babel/runtime/helpers/getPrototypeOf";import _inherits from"@babel/runtime/helpers/inherits";import _assertThisInitialized from"@babel/runtime/helpers/assertThisInitialized";import _defineProperty from"@babel/runtime/helpers/defineProperty";import _asyncIterator from"@babel/runtime/helpers/asyncIterator";import _awaitAsyncGenerator from"@babel/runtime/helpers/awaitAsyncGenerator";import _wrapAsyncGenerator from"@babel/runtime/helpers/wrapAsyncGenerator";/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */import Route from"route-parser";import isFunction from"lodash/isFunction";import qs from"qs";import merge from"lodash/merge";import cloneDeep from"lodash/cloneDeep";import{configureCache,cache}from"./serviceWorker";import ClientContext from"./ClientContext";import EventEmitter from"eventemitter3";/**
 * Provides routing for MUR-based applications and PWAs.  This class is inspired by express and uses https://github.com/rcs/route-parser,
 * which supports sophisticated pattern matching including optional paths, params, and splatting.
 *
 * Example:
 *
 *  const router = new Router()
 *
 *  router.get('/products/:id', ({ id }) => {
 *    // fetch product from upstream API (you'll need to write this function)
 *    return fetchProduct(id).then(result => {
 *      return result.product // this will be the result of router.run()
 *    })
 *  })
 *
 *  // assuming env.path = /products/1 and env.method = 'GET'
 *  router.run() // => the details for product 1
 *
 * Routes can be divided into multiple files to increase maintainability using the "use()" method.  For example:
 *
 *  // /scripts/api/router.js
 *
 *  const appShell = require('/build/index.html.js)
 *
 *  module.exports = new Router()
 *    .fallback(() => appShell) // render the PWA's app shell for all unmatched routes
 *    .use('/products', require('/api/products.js'))
 *
 *
 *  // /scripts/api/products.js
 *
 *  module.exports = new Router()
 *    .get('/:id', ({ id }) => new Promise((resolve, reject) => {
 *      // fetch product from upstream API...
 *     }))
 *
 *
 *  // /scripts/index.js
 *
 *  const router = require('/api/router')
 *
 *  module.exports = function() {
 *    // ...
 *    router.run().then((result) => {
 *      const body = typeof result === 'string' ? result : JSON.stringify(result)
 *      sendResponse({ body, htmlparsed: true })
 *    })
 *  }
 */var Router=/*#__PURE__*/function(a){function b(){var a;return _classCallCheck(this,b),a=_possibleConstructorReturn(this,_getPrototypeOf(b).call(this)),_defineProperty(_assertThisInitialized(_assertThisInitialized(a)),"onLocationChange",/*#__PURE__*/function(){var b=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function b(c,d,e){var f,g,h,i,j,k,l,m,n,o,p,q;return _regeneratorRuntime.wrap(function(b){for(;;)switch(b.prev=b.next){case 0:if("REPLACE"!==e){b.next=2;break}return b.abrupt("return");case 2:if(d.pathname!==a.prevLocation.pathname||d.search!==a.prevLocation.search){b.next=4;break}return b.abrupt("return");case 4:if(a.prevLocation=d,f=d.pathname,g=d.search,h={path:f,search:g,query:qs.parse(g),method:"GET"},i=new ClientContext,j=d.state,j&&c(j,e),a.emit("before",{request:h,response:i}),"PUSH"!==e&&j){b.next=47;break}k=!0,l=!1,b.prev=14,n=_asyncIterator(a.run(h,i,{historyState:j}));case 16:return b.next=18,n.next();case 18:return o=b.sent,k=o.done,b.next=22,o.value;case 22:if(p=b.sent,k){b.next=29;break}q=p,c(q,e);case 26:k=!0,b.next=16;break;case 29:b.next=35;break;case 31:b.prev=31,b.t0=b["catch"](14),l=!0,m=b.t0;case 35:if(b.prev=35,b.prev=36,k||null==n.return){b.next=40;break}return b.next=40,n.return();case 40:if(b.prev=40,!l){b.next=43;break}throw m;case 43:return b.finish(40);case 44:return b.finish(35);case 45:b.next=48;break;case 47:j&&c(j,e);case 48:a.emit("after",{request:h,response:i});case 49:case"end":return b.stop();}},b,this,[[14,31,35,45],[36,,40,44]])}));return function(){return b.apply(this,arguments)}}()),a.routes=[],a.isBrowser="client"===process.env.MOOV_RUNTIME,a.fallbackHandlers=[{runOn:{client:!0,server:!0},fn:function a(){return{page:"404"}}}],a.errorHandler=function(a,b,c,d){return console.error("Error caught with params",b," and with message:",a.message),d&&d.status&&d.status(500,"error"),{page:"Error",error:a.message,stack:a.stack,loading:!1}},a}return _inherits(b,a),_createClass(b,[{key:"pushRoute",value:function d(a,b,c){return this.routes.push({path:new Route(b+".:format"),method:a,handlers:c}),this.routes.push({path:new Route(b),method:a,handlers:c}),this}/**
   * Registers a GET route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:"get",value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute("GET",a,c)}/**
   * Registers a POST route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:"post",value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute("POST",a,c)}/**
   * Registers a PATCH route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:"patch",value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute("PATCH",a,c)}/**
   * Registers a PUT route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:"put",value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute("PUT",a,c)}/**
   * Registers a DELETE route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:"delete",value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute("DELETE",a,c)}/**
   * Registers an OPTIONS route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:"options",value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute("OPTIONS",a,c)}/**
   * Designates the handlers for unmatched routes
   * @param {Function} callback A function that returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:"fallback",value:function d(){for(var a=arguments.length,b=Array(a),c=0;c<a;c++)b[c]=arguments[c];return this.fallbackHandlers=b,this}/**
   * Sets the handler for errors thrown during route handling
   * @param {Function} handler A function that returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:"error",value:function b(a){return this.errorHandler=a,this}/**
   * Registers a set of nested routes.
   *
   * Example:
   *
   *  Router root = new Router()
   *
   *  Router products = new Router()
   *  products.get('/:id', ({ id }) => {
   *    return Promise.resolve(id)
   *  })
   *
   *  root.use('/products', products)
   *
   *  // url: /products/1
   *  root.run().then(result => console.log(result)) // => 1
   *
   * @param {String} path The parent path
   * @param {Router} router A router to handle the nested routes
   * @return {Router} this
   */},{key:"use",value:function k(a,b){var c=!0,d=!1,e=void 0;try{for(var f,g=b.routes[Symbol.iterator]();!(c=(f=g.next()).done);c=!0){var h=f.value,i=h.path,j=_objectWithoutProperties(h,["path"]);this.routes.push(_objectSpread({path:new Route(a+i.spec)},j))}}catch(a){d=!0,e=a}finally{try{c||null==g.return||g.return()}finally{if(d)throw e}}return this}/**
   * @private
   * Caches the initialState (json) and HTML using the service worker.
   * @param {Object} request
   */},{key:"cacheInitialState",value:function b(a){cache(a.path+qs.stringify(a.query),"<!DOCTYPE html>\n".concat(document.documentElement.outerHTML))}/**
   * Configures service worker runtime caching options
   * @param {Object} options
   * @param {Object} options.cacheName The name of the runtime cache
   * @param {Object} options.maxEntries The max number of entries to store in the cache
   * @param {Object} options.maxAgeSeconds The TTL in seconds for entries
   * @return {Router} this
   */},{key:"configureClientCache",value:function b(a){return configureCache(a),this}/**
   * Gets the server cache key for the matching route.
   * @param {Object} request
   * @param {Object} defaults The default values used for the cache key
   * @return {Object} An object populate with keys and values that when hashed, make up the cache key
   */},{key:"getCacheKey",value:function g(a,b){var c=this.findMatchingRoute(a),d=c.match,e=d?d.handlers:this.fallbackHandlers;if(!e)return b;var f=e.find(function(a){return"cache"===a.type});return f&&f.server&&f.server.key?f.server.key(a,b):b}/**
   * Creates an object describing the browser location
   * @return {Object}
   */},{key:"createLocation",value:function a(){return{protocol:location.protocol.replace(/:/,""),pathname:location.pathname,search:location.search,hostname:location.hostname,port:location.port}}/**
   * Runs the current url (from env) and generates a result from each the matching route's handlers.
   * @param {Object} request The request being served
   * @param {String} request.path The url path
   * @param {String} request.method The http method
   * @param {Response} response The response object
   * @param {Object} options
   * @param {Boolean} [options.initialLoad=false] Set to true if this is the initial load of the application.  This will cause the HTML to be cached for the current path
   * @return {Object} Generates state objects
   */},{key:"run",value:function i(a,b){var c=this,d=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},e=d.initialLoad,f=void 0!==e&&e,g=d.historyState,h=void 0===g?{}:g;return _wrapAsyncGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function d(){var e,g,i,j,k,l,m,n,o,p,q,r;return _regeneratorRuntime.wrap(function(d){for(;;)switch(d.prev=d.next){case 0:if(e=c.findMatchingRoute(a),g=e.match,i=e.params,a.params=i,j=g?g.handlers:c.fallbackHandlers,k=!f&&j.some(function(a){return"fromServer"===a.type}),!c.isBrowser){d.next=7;break}return d.next=7,_objectSpread({loading:k,location:c.createLocation()},h);case 7:d.prev=7,l=!0,m=!1,n=void 0,d.prev=11,o=j[Symbol.iterator]();case 13:if(l=(p=o.next()).done){d.next=33;break}if(q=p.value,"function"==typeof q&&(q={runOn:{server:!0,client:!0},fn:q}),!(f&&"cache"!==q.type)){d.next=18;break}return d.abrupt("continue",30);case 18:if(q.runOn.client||!c.isBrowser){d.next=20;break}return d.abrupt("continue",30);case 20:if(q.runOn.server||c.isBrowser){d.next=22;break}return d.abrupt("continue",30);case 22:if(!(a.path.endsWith(".json")&&(!0!==q.runOn.server||c.isBrowser))){d.next=24;break}return d.abrupt("continue",30);case 24:return d.next=26,_awaitAsyncGenerator(c.toPromise(q.fn,i,a,b));case 26:if(r=d.sent,!r){d.next=30;break}return d.next=30,r;case 30:l=!0,d.next=13;break;case 33:d.next=39;break;case 35:d.prev=35,d.t0=d["catch"](11),m=!0,n=d.t0;case 39:d.prev=39,d.prev=40,l||null==o.return||o.return();case 42:if(d.prev=42,!m){d.next=45;break}throw n;case 45:return d.finish(42);case 46:return d.finish(39);case 47:f&&"force-cache"===b.clientCache&&c.cacheInitialState(a,b),d.next=54;break;case 50:return d.prev=50,d.t1=d["catch"](7),d.next=54,c.errorHandler(d.t1,i,a,b);case 54:case"end":return d.stop();}},d,this,[[7,50],[11,35,39,47],[40,,42,46]])}))()}/**
   * Runs all client and server handlers for the specified path and method
   * @param {Object} request The request being served
   * @param {String} request.path The url path
   * @param {String} request.method The http method
   * @param {Response} response The response object
   * @param {Object} options
   * @param {Object} [state={}] The accumulated state from other handlers
   * @return {Object} The merged result of all handlers
   */},{key:"runAll",value:function(){var a=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(b,c,d){var e,f,g,h,i,j,k,l,m=arguments;return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:e=3<m.length&&void 0!==m[3]?m[3]:{},e=cloneDeep(e),f=!0,g=!1,a.prev=4,i=_asyncIterator(this.run(b,c,d));case 6:return a.next=8,i.next();case 8:return j=a.sent,f=j.done,a.next=12,j.value;case 12:if(k=a.sent,f){a.next=19;break}l=k,"string"==typeof l?e=l:merge(e,l);case 16:f=!0,a.next=6;break;case 19:a.next=25;break;case 21:a.prev=21,a.t0=a["catch"](4),g=!0,h=a.t0;case 25:if(a.prev=25,a.prev=26,f||null==i.return){a.next=30;break}return a.next=30,i.return();case 30:if(a.prev=30,!g){a.next=33;break}throw h;case 33:return a.finish(30);case 34:return a.finish(25);case 35:return a.abrupt("return",e);case 36:case"end":return a.stop();}},a,this,[[4,21,25,35],[26,,30,34]])}));return function b(){return a.apply(this,arguments)}}()/**
   * Converts specified callback to a promise
   * @param {Function/Object} callback A function that returns a Promise that
   *  resolves to the new state, a function that returns the new state, or the new state itself.
   * @param {Object} params The request parameters
   * @param {Object} request The request object with body and headers
   * @param {Response} response The response object
   */},{key:"toPromise",value:function e(a,b,c,d){if(isFunction(a)){var f=a(b,c,d);return f&&f.then?f:Promise.resolve(f)}// callback is the new state
return Promise.resolve(a)}/**
   * Returns the matching route and parsed params for the specified path and method
   * @param {Object} request The http request
   * @return {Object} an object with match and params
   */},{key:"findMatchingRoute",value:function h(a){var b,c=a.path,d=a.query,e=a.method,f=void 0===e?"GET":e;f=f.toUpperCase();var g=this.routes.filter(function(a){return f===a.method}).find(function(a){return b=a.path.match(c)});return{match:g,params:_objectSpread({},b,d)}}/**
   * Returns true if the route will result in the server connecting to the
   * upstream site due to the presence of a `proxyUpstream` handler, otherwise
   * false.
   * @private
   * @param {Object} request
   * @return {Boolean}
   */},{key:"willFetchFromUpstream",value:function e(a){var b=this.findMatchingRoute(a),c=b.match,d=c?c.handlers:this.fallbackHandlers;return d.some(function(a){return"proxyUpstream"===a.type})}/**
   * Called when the location is changed on the client
   * @param {Function} callback A callback to pass the new state to
   * @param {Object} location The new location
   */},{key:"reloadFromServer",/**
   * Call this function when client-side navigation to a non-PWA route has occurred.  This
   * will revert window.history to the previous url and reload the original destination URL
   * from the server.
   * @private
   */value:function b(){var a=window.location.href;this.history.goBack(),self.location.href=a}/**
   * Calls the specified callback whenever the current URL changes
   * @param {History} history
   * @param {Function} callback
   * @return {Router} this
   */},{key:"watch",value:function h(a,b){this.history=a,this.prevLocation=a.location,a.listen(this.onLocationChange.bind(this,b));var c=a.location,d=c.pathname,e=c.search,f={path:d,search:e,query:qs.parse(e),method:"GET"},g=new ClientContext(f);return this.runAll(f,g,{initialLoad:!0},window.initialState),this.emit("after",{request:f,response:g,initialLoad:!0}),this}/**
   * Provides an easy way to navigate by changing some but not all of the query params.  Any keys
   * included in the params object are applied as new query param values.  All other query params are preserved.
   * @param {Object} params Key/value pairs to apply to the query string.  Specifying a value of undefined or null will remove that parameter from the query string
   */},{key:"applySearch",value:function d(a){var b=this.history,c=qs.stringify(_objectSpread({},qs.parse(b.location.search,{ignoreQueryPrefix:!0}),a));b.replace("".concat(b.location.pathname,"?").concat(c))}}]),b}(EventEmitter);export{Router as default};
//# sourceMappingURL=Router.js.map