import _objectSpread from"@babel/runtime/helpers/objectSpread";import _regeneratorRuntime from"@babel/runtime/regenerator";import"core-js/modules/es6.string.ends-with";import"regenerator-runtime/runtime";import"core-js/modules/es6.regexp.search";import _asyncToGenerator from"@babel/runtime/helpers/asyncToGenerator";/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */import{fetchLatest,StaleResponseError}from"../fetchLatest";import{abortPrefetches,resumePrefetches}from"./serviceWorker";var doFetch;/**
 * Fetch's state as json from the specified url
 * @param {String} url The url to fetch
 * @param {Object} options 
 * @param {String} options.cache Set to "force-cache" to cache the response in the service worker.  Omit to skip the service worker cache.
 * @return {Object} A state patch
 */export function fetch(){return _fetch.apply(this,arguments)}/**
 * Handles a redirect response.  Will do a client side navigation if the URL has the same hostname as the app, otherwise will
 * reload the page.
 * @param {String} url 
 */function _fetch(){return _fetch=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(b){var c,d,e,f,g,h,i,j=arguments;return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:return c=1<j.length&&void 0!==j[1]?j[1]:{},d=c.cache,e=void 0===d?"default":d,abortPrefetches(),doFetch=doFetch||fetchLatest(require("isomorphic-unfetch")),f=location,g=f.href,a.prev=4,h=(window.moov||{}).apiVersion,a.next=8,doFetch(b,{cache:e||"default",credentials:"include",headers:{"x-react-storefront":"true",// allows back end handlers to quickly identify PWA API requests,
"x-moov-api-version":h// needed for the service worker to determine the correct runtime cache name and ensure that we're not getting a cached response from a previous api version
}}).then(function(a){var b=a.redirected,c=a.url;return b?void redirectTo(c):(resumePrefetches(),a.json())});case 8:if(i=a.sent,null==i||location.href!==g){a.next=11;break}return a.abrupt("return",_objectSpread({loading:!1},i));case 11:a.next=20;break;case 13:if(a.prev=13,a.t0=a["catch"](4),!StaleResponseError.is(a.t0)){a.next=19;break}return a.abrupt("return",null);case 19:throw a.t0;case 20:case"end":return a.stop();}},a,this,[[4,13]])})),_fetch.apply(this,arguments)}function redirectTo(a){if(a){var b=new URL(a),c=window.moov.history;b.hostname===window.location.hostname?c.push(b.pathname+b.search):window.location.assign(a)}else throw new Error("Received a redirect without a location header.")}/**
 * Creates a handler that fetches data from the server.
 * 
 * The `handlerPath` should point to a module that exports a function that takes params, request, and response, 
 * and returns an object that should be applied to the app state.  For example:
 * 
 *  // routes.js
 *  router.get('/p/:id'
 *    fromServer('./product/product-handler')
 *  )
 * 
 *  // product/product-handler.js
 *  export default function productHandler(params, request, response) {
 *    return fetchFromUpstreamApi(`/products/${params.id}`)
 *      .then(res => res.json())
 *      .then(productData => ({ // the shape of this object should match your AppModel
 *        page: 'Product',
 *        product: productData
 *      }))
 *  }
 * 
 * When the request path ends in ".json", the json response will be returned verbatim.  In all other cases, server-side rendered HTML
 * will be returned.
 * 
 * You can also send a verbatim string response using `response.send(body)`.  For example:
 * 
 *  // routes.js
 *  router.get('/my-api'
 *    fromServer('./my-api-handler')
 *  )
 * 
 *  // my-api-handler.js
 *  export default function myApiHandler(params, request, response) {
 *    response
 *      .set('content-type', response.JSON)
 *      .send(JSON.stringify({ foo: 'bar' }))
 *  }
 * 
 * When `response.send()` is called in a handler, react-storefront will never perform server-side rendering.
 * 
 * @param {String} handlerPath The path to the module that exports a handler function that returns state to apply
 * @param {Function} getURL An optional function that returns the back end url to call when fetching.  You only need 
 *   to specify this if you want to override the default URL.
 * @return {Function}
 */export default function fromServer(a,b){return{type:"fromServer",runOn:{server:!0,client:!0// fromServer handlers run on the client too - we make an ajax request to get the state from the server
},fn:function(){var c=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function c(d,e,f){var g;return _regeneratorRuntime.wrap(function(c){for(;;)switch(c.prev=c.next){case 0:if("string"!=typeof a){c.next=6;break}return g="".concat(location.pathname,".json").concat(location.search),b&&(g=b(g)),c.abrupt("return",fetch(g,{cache:f.clientCache}));case 6:if(null!=a){c.next=8;break}throw new Error("You must provide a path to a handler in fromServer().  Please check your routes.");case 8:return f.set("x-rsf-handler",a.path),f.set("x-rsf-response-type",e.path.endsWith(".json")?"json":"ssr"),c.abrupt("return",a(d,e,f));case 11:case"end":return c.stop();}},c,this)}));return function a(){return c.apply(this,arguments)}}()}}
//# sourceMappingURL=fromServer.js.map