import"core-js/modules/es6.promise";import"core-js/modules/es6.regexp.search";import"core-js/modules/es6.string.starts-with";import _regeneratorRuntime from"@babel/runtime/regenerator";import"regenerator-runtime/runtime";import _asyncToGenerator from"@babel/runtime/helpers/asyncToGenerator";/**
 * @license
 * Copyright © 2017-2019 Moov Corporation.  All rights reserved.
 */ /**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */ /**
 * Cache content using the service worker.  If content is not supplied, the service worker will fetch
 * the content from the server
 * @param {String} path The URI path of the request
 * @param {String} cacheData The data to cache
 */export function cache(){return _cache.apply(this,arguments)}/**
 * Prefetches and caches JSON for the specified path
 * @param {String} path A URL path for a page (without .json)
 */function _cache(){return _cache=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(b,c){var d;return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:return a.next=2,waitForServiceWorkerController();case 2:if(!a.sent){a.next=5;break}d=window.moov.apiVersion,c?navigator.serviceWorker.controller.postMessage({action:"cache-state",path:b,apiVersion:d,cacheData:c}):navigator.serviceWorker.controller.postMessage({action:"cache-path",path:b,apiVersion:d});case 5:case"end":return a.stop();}},a,this)})),_cache.apply(this,arguments)}export function prefetchJsonFor(){return _prefetchJsonFor.apply(this,arguments)}/**
 * Prefetches and caches SSR and JSON for the specified path
 * @param {String} path A URL path for a page (without .json)
 */function _prefetchJsonFor(){return _prefetchJsonFor=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(b,c){var d,e;return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:if(b){a.next=2;break}return a.abrupt("return");case 2:b.startsWith("http")?(d=new URL(b),cache("".concat(d.origin).concat(d.pathname,".json").concat(d.search))):(e=new URL("http://z.z".concat(b)),cache("".concat(e.pathname,".json").concat(e.search))),c&&cache(b);case 4:case"end":return a.stop();}},a,this)})),_prefetchJsonFor.apply(this,arguments)}export function prefetch(a){cache(a),prefetchJsonFor(a)}/**
 * Aborts all in progress prefetches.  Call this function to prevent prefetching from blocking
 * more important requests, like page navigation.
 */export function abortPrefetches(){return _abortPrefetches.apply(this,arguments)}/**
 * Resume queued prefetch requests which were cancelled to allow for more important requests
 */function _abortPrefetches(){return _abortPrefetches=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(){return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:return a.next=2,waitForServiceWorkerController();case 2:if(!a.sent){a.next=4;break}navigator.serviceWorker.controller.postMessage({action:"abort-prefetches"});case 4:case"end":return a.stop();}},a,this)})),_abortPrefetches.apply(this,arguments)}export function resumePrefetches(){return _resumePrefetches.apply(this,arguments)}/**
 * Configures runtime caching options
 * @param {Object} options 
 * @param {Object} options.cacheName The name of the runtime cache
 * @param {Object} options.maxEntries The max number of entries to store in the cache
 * @param {Object} options.maxAgeSeconds The TTL in seconds for entries
 */function _resumePrefetches(){return _resumePrefetches=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(){return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:return a.next=2,waitForServiceWorkerController();case 2:if(!a.sent){a.next=4;break}navigator.serviceWorker.controller.postMessage({action:"resume-prefetches"});case 4:case"end":return a.stop();}},a,this)})),_resumePrefetches.apply(this,arguments)}export function configureCache(){return _configureCache.apply(this,arguments)}/**
 * Resolves when the service worker has been installed
 */function _configureCache(){return _configureCache=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(b){return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:return a.next=2,waitForServiceWorkerController();case 2:if(!a.sent){a.next=4;break}navigator.serviceWorker.controller.postMessage({action:"configure-runtime-caching",options:b});case 4:case"end":return a.stop();}},a,this)})),_configureCache.apply(this,arguments)}function waitForServiceWorkerController(){return _waitForServiceWorkerController.apply(this,arguments)}/**
 * Removes runtime caches for old versions of the api.  This ensures that all responses
 * are appropriate for the current version of the UI.
 */function _waitForServiceWorkerController(){return _waitForServiceWorkerController=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(){return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:if(navigator.serviceWorker&&navigator.serviceWorker.controller){a.next=2;break}return a.abrupt("return",!1);case 2:return a.abrupt("return",new Promise(function(a){navigator.serviceWorker.ready.then(function(){return navigator.serviceWorker.controller?a(!0):void navigator.serviceWorker.addEventListener("controllerchange",function(){return a(!0)})})}));case 3:case"end":return a.stop();}},a,this)})),_waitForServiceWorkerController.apply(this,arguments)}export function removeOldCaches(){return _removeOldCaches.apply(this,arguments)}function _removeOldCaches(){return _removeOldCaches=_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function a(){return _regeneratorRuntime.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:return a.next=2,waitForServiceWorkerController();case 2:if(!a.sent){a.next=4;break}navigator.serviceWorker.controller.postMessage({action:"remove-old-caches",apiVersion:window.moov.apiVersion});case 4:case"end":return a.stop();}},a,this)})),_removeOldCaches.apply(this,arguments)}export default{removeOldCaches:removeOldCaches,waitForServiceWorkerController:waitForServiceWorkerController,configureCache:configureCache,resumePrefetches:resumePrefetches,abortPrefetches:abortPrefetches,prefetch:prefetch,prefetchJsonFor:prefetchJsonFor,cache:cache};
//# sourceMappingURL=serviceWorker.js.map