import"core-js/modules/es6.array.iterator";import"core-js/modules/es6.object.keys";import"core-js/modules/web.dom.iterable";import"core-js/modules/es6.promise";import _toConsumableArray from"@babel/runtime/helpers/toConsumableArray";/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */ /**
 * Method for checking script tag in <head>
 * @param {String} src path to script
 */function isScriptInjected(a){if("undefined"==typeof document)return!1;var b=_toConsumableArray(document.querySelectorAll("script[src^=\"".concat(a,"\"]")));return 0<b.length}/**
 * Method for checking script tag in <head>
 * @param {String} code script code
 */function isCodeInjected(a){if("undefined"==typeof document)return!1;var b=_toConsumableArray(document.head.getElementsByTagName("script")).filter(function(b){return b.innerHTML===a});return 0<b.length}/**
 * Method for injecting script tag in <head>
 * @param {String} src path to script
 * @param {Object} [params] Optional params
 * @param {Object} [params.attrs={}] Optional attributes to add to element
 * @param {Boolean} [params.once=true] If true then script will be injected only once
 * @returns {Promise} Promise returns on script's onload event
 */export function injectScriptInHead(a){var b=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},c=b.attrs,d=void 0===c?{}:c,e=b.once;if((void 0===e||e)&&isScriptInjected(a))return Promise.resolve();if("undefined"==typeof document)return Promise.resolve();var f,g=document.createElement("script");return g.src=a,Object.keys(d).forEach(function(a){g.setAttribute(a,d[a])}),f=new Promise(function(a,b){g.onload=a,g.onerror=b}),document.head.appendChild(g),f}/**
 * Method for injecting target code in <head>
 * @param {String} code script code
 * @param {Object} [params] optional params
 * @param {Boolean} [params.once=false] If true then script will be injected only once
 */export function injectCodeInHead(a){var b=1<arguments.length&&arguments[1]!==void 0?arguments[1]:{},c=b.once;if(!((!(void 0!==c)||c)&&isCodeInjected(a))&&"undefined"!=typeof document){var d=document.createElement("script");d.appendChild(document.createTextNode(a)),document.head.appendChild(d)}}/**
 * Method for removing script in <head>
 * @param {String} src path to script
*/export function removeScriptInHead(a){_toConsumableArray(document.querySelectorAll("script[src^=\"".concat(a,"\"]"))).forEach(function(a){return a.parentNode.removeChild(a)})}/**
 * Method for removing code  in <head>
 * @param {String} code script code
*/export function removeCodeInHead(a){_toConsumableArray(document.head.getElementsByTagName("script")).filter(function(b){return b.innerHTML===a}).forEach(function(a){return a.parentNode.removeChild(a)})}var scriptInjector={injectScriptInHead:injectScriptInHead,injectCodeInHead:injectCodeInHead,removeScriptInHead:removeScriptInHead,removeCodeInHead:removeCodeInHead};export default scriptInjector;
//# sourceMappingURL=scriptInjector.js.map